/**
  *  \file client/scr-result.h
  *
  *  (c) 2001-2009 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_SCR_RESULT_H
#define PCC_V2_CLIENT_SCR_RESULT_H

#include "game/sim-result.h"
#include "ui/ui.h"
#include "ui/window.h"
#include "ui/listbox.h"
#include "ui/widgets.h"

class WSimList;

class WSimClassResultList : public UIListbox {
    GSimResultSummary& result;
    GPlayerSet players;
    int desc_width;
    int column_width;
 public:
    WSimClassResultList(GPlayerSet players, GSimResultSummary& result);
    ~WSimClassResultList();

    void drawPart(GfxCanvas& can, int from, int to);
    void drawContent(GfxCanvas& can);
    void onResize(GfxRect old_size, bool by_layout);

    void updateFromResult();
};

class WSimResultWindow : public UIWindow {
    const GSimState&   sim_setup;
    const GSimOptions& sim_options;
    GSimBattleResult   last_result;
    GSimResultSummary  result_summary;

    ObjectHolder holder;

    WSimClassResultList class_result_list;
    UIStaticText summary_line;     // on summary screen
    UIStaticText summary_line2;    // on details screen

    UICardGroup tab_content;
    UICardGroupTab tabs;

    WSimList& result_list;

    Signal0 sig_run;

    void updateResults();
 public:
    WSimResultWindow(const GSimState& sim_setup, const GSimOptions& sim_options);
    ~WSimResultWindow();

    void runSimulation(bool series, int max);
    bool runFirstSimulation();
    bool handleEvent(const UIEvent& event, bool second_pass);

    int getResultListIndex() const;
};

#endif
