/**
  *  \file client/wcost.h
  *
  *  (c) 2001-2009 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_WCOST_H
#define PCC_V2_CLIENT_WCOST_H

#include "ui/ui.h"
#include "game/cargo.h"
#include "game/cost.h"

class GCargoCostTransaction;

class WItemCostDisplay : public UIWidget {
 private:
    GCargoCostTransaction&  action;
    GCost                   cost;
    int                     have_tech, need_tech;
    bool                    include_item_in_cost;
 public:
    WItemCostDisplay(GCargoCostTransaction& action, bool include_item_in_cost);
    ~WItemCostDisplay();

    void getLayoutInfo(LayoutInfo& li);
    bool handleEvent(const UIEvent& e, bool second_pass);
    void drawContent(GfxCanvas& can);

    void setCost(const GCost&);
    void setTech(int have, int need);
};

#endif
