/**
  *  \file game/save.h
  *
  *  (c) 2001-2009 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_GAME_SAVE_H
#define PCC_V2_GAME_SAVE_H

#include "cpluslib/smartptr.h"
#include "cpluslib/types.h"
#include "io/dirs.h"
#include "io/streams.h"
#include "game/player.h"

class GGameTurn;
class GUniverse;

enum {
    /* Flags for saving */
    save_ChecksumCount = 1
};

void saveShips(const GUniverse& univ, Stream& str, const GPlayerSet src, uint32* checksum, const int flags);
void savePlanets(const GUniverse& univ, Stream& str, const GPlayerSet src, uint32* checksum, const int flags);
void saveBases(const GUniverse& univ, Stream& str, const GPlayerSet src, uint32* checksum, const int flags);

uint32 computeShipChecksum(const GUniverse& univ, const GPlayerSet src, const int flags);
uint32 computePlanetChecksum(const GUniverse& univ, const GPlayerSet src, const int flags);
uint32 computeBaseChecksum(const GUniverse& univ, const GPlayerSet src, const int flags);

void saveDirectory(GGameTurn& trn, Directory& dir, GPlayerSet player_mask);
void saveTurns(GGameTurn& trn, Directory& dir, GPlayerSet player_mask);

#endif
